//+------------------------------------------------------------------+
//|                                                         test.mq5 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

extern double lot_size  =  0.1;     // lot size that use for trade
extern int     magic_num   =     786;
extern int        pips  =  10; // Distance between levels

extern string ex1 = "Default H1 Setting";
 int change_SL_onpips = 150;//Change when market move 200 in positive
/*extern*/ int initial_sl = 250;
//extern int max_sl_5_digit = 250;
//extern int max_sl_3_digit = 15;

 int order_pips_after_signal = 15;
 int stop_when_orange_show = 18;

extern string ex2 = "SL/TP in Pips on order open";
extern int max_sl = 220; //use in modify
extern int max_tp = 500; //

double prevtime[2];
int spread = 3;
int oldColor= 0;
double changeprice = 0;
string str_color = "";
double pt;
int my_slippage = 3;
bool orange_start = true;
double orange_price = 0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if(pips<MarketInfo(Symbol(),MODE_STOPLEVEL)+spread) pips=1+MarketInfo(Symbol(),MODE_STOPLEVEL)+spread;
   if(lot_size<MarketInfo(Symbol(),MODE_MINLOT)) lot_size=MarketInfo(Symbol(),MODE_MINLOT);

   if(Digits==3 || Digits==5){
      pt=Point*10;
   }else{
      pt=Point;
   }
      

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){
//---
     get_signal();
  //   auto_modify(); //Auto SL change
}

/* 3 Digits
121.776 +0.1 = 121.777
121.776 +2 = 121.796

5 Digits
1.07776 + 0.1 = 1.07777
1.07776 + 2 = 1.07796

Close[2], = " add 0.1: ",Close[2]+0.1*pt
 Print("vallll normal1: ",Close[2]," add 0.1: ",Close[2]+0.1*pt);
 Print("vallll normal2: ",Close[2]," add 0.3: ",Close[2]+0.3*pt);
 Print("vallll normal3: ",Close[2]," add 2: ",Close[2]+2*pt);
 
 
 
*/


  
void get_signal(){
   
   if (ObjectsTotal() == 0) { return(0); }
  
   int i;
   for (i=0;i<ObjectsTotal();i++){
      string name = ObjectName(i);
     // Print("return =------------------------",StringFind(line,"buy",0));
      if(StringFind(name,"RC-Stp",0) == 0){
            double rctime = ObjectGet(name,OBJPROP_TIME1);
            string num = StringSubstr(name,6,1);
            if(rctime == Time[0]){
                 double sl = ObjectGet(name,OBJPROP_PRICE1);
                 double tp = ObjectGet("RC-Trg"+num,OBJPROP_PRICE1);

                 place_order(sl,tp);
            }
      }

   }
  
} 


void place_order(double sl,double tp){
 if(prevtime[0]!=Time[0] && sl>0 && tp>0){
   //buy
   if(sl<tp){
      //buy
       prevtime[0]=Time[0];
       close_open_order("sell");
       buy_order(sl,tp);
   }
   if(sl>tp){
       prevtime[0]=Time[0];
      //sell
       close_open_order("buy");
       sell_order(sl,tp);
    }
 }
  

}




void buy_order(double SL,double TP)
{

      int price=MathAbs(NormalizeDouble(Close[0]-SL,Digits)/Point); // 10-6
      if(price>max_sl){
         SL = min_pips_in_price(Ask,max_sl);
      }
      
      price=MathAbs(NormalizeDouble(Close[0]-TP,Digits)/Point); // 10-6
      // minus 3% from TP
      double new_pips = (price*3)/100;
      price = price-new_pips;
      if(price>max_tp){
         TP = add_pips_in_price(Ask,max_tp);
      }else if(price > 100){
         TP = add_pips_in_price(Ask,price);
      }
      
 //  if(is_order_open() == false){
      string comment="Buy auto Type: ";
      OrderSend(Symbol(),OP_BUY,lot_size,Ask,my_slippage,SL,TP,comment,magic_num);
 //  }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sell_order(double SL,double TP)
{

 //  if(is_order_open() == false){
      int price=MathAbs(NormalizeDouble(SL-Close[0],Digits)/Point); // 10-6
      if(price>max_sl){
         SL = add_pips_in_price(Bid,max_sl);
      }
      
      price=MathAbs(NormalizeDouble(TP-Close[0],Digits)/Point); // 10-6
      // minus 3% from TP
      double new_pips = (price*3)/100;
      price = price-new_pips;
      
      if(price>max_tp){
         TP = min_pips_in_price(Bid,max_tp);
      }else if(price > 100){
         TP = min_pips_in_price(Bid,price);
      }
      
      string comment="Sell auto Type: ";
      OrderSend(Symbol(),OP_SELL,lot_size,Bid,my_slippage,SL,TP,comment,magic_num);
 // }
} 
  



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double add_pips_in_price(double price,double pip)
  {
   double newPrice=0;
   if(Digits==5)
     {
      newPrice=price+(pip/100000);
        }else if(Digits==4){
      newPrice=price+(pip/10000);
        }else if(Digits==3){
      newPrice=price+(pip/1000);
     }
   return (newPrice);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double min_pips_in_price(double price,double pip)
  {
   double newPrice=0;
   if(Digits==5)
     {
      newPrice=price -(pip/100000);
        }else if(Digits==4){
      newPrice=price -(pip/10000);
        }else if(Digits==3){
      newPrice=price -(pip/1000);
     }
   return (newPrice);
  }
//+------------------------------------------------------------------+


bool is_order_open(){
   int OrderCnt,total=OrdersTotal();
   for(OrderCnt=0;OrderCnt<total;OrderCnt++)
   {
      OrderSelect(OrderCnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == magic_num) {
           return true;
      }
    }
  
  return false;
}

bool close_open_order(string old_trend = "buy"){
   int OrderCnt,total=OrdersTotal();
   for(OrderCnt=0;OrderCnt<total;OrderCnt++)
   {
      OrderSelect(OrderCnt,SELECT_BY_POS,MODE_TRADES);

      if(OrderSymbol()==Symbol() && OrderMagicNumber() == magic_num && OrderType() == OP_SELL && old_trend == "sell") {
            OrderClose(OrderTicket(),lot_size,Ask,my_slippage);
      }
      
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == magic_num && OrderType() == OP_BUY && old_trend == "buy") {
          OrderClose(OrderTicket(),lot_size,Bid,my_slippage);
      }
   }
  
  return false;
}


double profit_price = 0;
int tick_count =0;
void auto_modify(){

   //run on each 5th tick
   if(tick_count < 5){
     tick_count++; 
     return;
   }
   tick_count = 0; 

   int OrderCnt,diff, total=OrdersTotal();
   double SL,openPrice,oldSL = 0;
   double TP =0;
   for(OrderCnt=0;OrderCnt<total;OrderCnt++){
      OrderSelect(OrderCnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == magic_num && OrderType() ==OP_BUY) {
        openPrice = OrderOpenPrice();
        oldSL     = OrderStopLoss();
        diff      =  MathAbs(NormalizeDouble(Close[0]-openPrice,Digits)/Point); // 10-6
     //   Print("Buy diff",diff);
        SL=min_pips_in_price(Bid,max_sl);
        if(diff > change_SL_onpips && oldSL < SL){
            TP = OrderTakeProfit();
            OrderModify( OrderTicket(), Ask, SL,TP,0);
        }
        
        
      }
      else if(OrderSymbol()==Symbol() && OrderMagicNumber() == magic_num && OrderType() ==OP_SELL){ 
         openPrice = OrderOpenPrice();
        diff=MathAbs(NormalizeDouble(openPrice-Close[0],Digits)/Point); // 10-6
     //   Print("Sell diff",diff);
        oldSL = OrderStopLoss();
        SL=add_pips_in_price(Ask,max_sl);
        if(diff > change_SL_onpips && oldSL > SL){
            TP = OrderTakeProfit();
            OrderModify( OrderTicket(), Bid, SL,TP,0);
        }
      }
    }
   
}